﻿// Learn more about F# at http://fsharp.net

open System
open System.IO 
open System.Runtime.Serialization
open System.Xml
open System.Xml.Linq 
open System.Xml.Serialization
open System.Collections 
open System.Collections.Generic
open System.Net 
open System.Text.RegularExpressions
open Microsoft.Search.Interop  
open System.Data 
  
(*
let GetUrlContents1(url: string): string =
    let uri = new Uri(url)
    let req = WebRequest.Create(uri) :?> HttpWebRequest
    req.UseDefaultCredentials <- true
    use stream = req.GetResponse().GetResponseStream()
    use reader = new IO.StreamReader(stream)
    reader.ReadToEnd()

let GetUrlContents2(url: string): string =
    let req = WebRequest.Create(url) :?> HttpWebRequest
    req.UseDefaultCredentials <- true
    use stream = req.GetResponse().GetResponseStream()
    use reader = new IO.StreamReader(stream)
    reader.ReadToEnd()

let html1 = GetUrlContents1("http://msdn.microsoft.com/ru-ru/library/dd233154.aspx")
let html2 = GetUrlContents2("http://msdn.microsoft.com/ru-ru/library/dd233154.aspx")
*)

(*
let SerializeObj<'t>(clsObj: obj, file: string) = 
    let ser: DataContractSerializer = new DataContractSerializer(typeof<'t>)
    use writer: FileStream = new FileStream(file, FileMode.Create)
    ser.WriteObject(writer, clsObj)

let DeserializeObj<'t>(file: string) = 
    let ser: DataContractSerializer = new DataContractSerializer(typeof<'t>)
    use reader: FileStream = new FileStream(file, FileMode.Open)
    ser.ReadObject(reader) :?> 't

let GetFilesToFolder(folder: string): string[] =
    folder
        |> Directory.GetFiles
        |> Array.map Path.GetFileName 

let InitHashSetToFolder(folder: string): HashSet<string> =
    new HashSet<string>(GetFilesToFolder(folder))
*)

(*
let hs = InitHashSetToFolder(@"G:\Projects\Visual_Studio_2010\FS\UrlDownLoader\TestFS\bin\Debug\")

let files = GetFilesToFolder(@"G:\Projects\Visual_Studio_2010\FS\UrlDownLoader\TestFS\bin\Debug\")
*)

//let hs = new HashSet<String>(files)
(*
let dataObj = new Dictionary<String,String>()
dataObj.Add("k1", "v1") 
dataObj.Add("k2", "v2")
SerializeObj<Dictionary<String,String>>(dataObj, "TestHashtable.xml")
let result: Dictionary<String,String> = DeserializeObj<Dictionary<String,String>>("TestHashtable.xml")
*)
(*
let ser: DataContractSerializer = new DataContractSerializer(typeof<SortedList<String,String>>)
let reader: FileStream = new FileStream("TestHashtable.xml", FileMode.Open)
let hashtable : SortedList<String,String> = ser.ReadObject(reader) :?> SortedList<String,String>
*)

(*
let xname thing = XName.Get(thing.ToString()) 
type xmlTag = 
    | Link of string*string
    | File of string
    member public this.ToXml() =
        match this with
        | Link(href, title) ->
            new XElement(xname "link",
                new XElement(xname "href", href),
                new XElement(xname "title", title))
        | File(file) ->
            new XElement(xname "file", file)

let convToXml(lst: xmlTag list) =
    let res = lst
            |> List.map(fun o -> o.ToXml())
            |> Array.ofList
    new XElement(xname "root", res)

let lstlnk = [Link("l1", "t1"); Link("l2", "t2")]
let r1 = convToXml(lstlnk)
let lstfls = [File("f1"); File("f2")]
let r2 = convToXml(lstfls)
*)

(*
let mutable xmd = new XmlDocument()
xmd.LoadXml("<links />") 
for (l, t) in lstlnk do 
    let mutable lnk = xmd.CreateElement("link") 
    let mutable ref = xmd.CreateElement("href") 
//    let ref = new XmlElement("href")
//    let tlt = new XmlElement("title")
    xmd.DocumentElement.AppendChild(lnk)
*)

(*
let SubfolderFiles = "Files"
let FileSiteInfo = "siteInfo.xml"
let CookieLangName = "CodeSnippetContainerLang"
let StyleExternalImage = "<style type=\"text/css\">.externImage{border-width:0;vertical-align:middle;margin:0}</style>"
let ExternalImage = "external.gif"
let ImgTagExternal = "<img class=\"externImage\" src=\"./" + SubfolderFiles + "/" + ExternalImage + "\" alt=\"" + ExternalImage + "\" />"
*)
(*
let ReplaceLinksToLocalFile(folder: string, url: string, localFile: string, httpFile: string): string =
    if (not <| String.IsNullOrEmpty(httpFile)) then
        let fileHttp = Path.Combine(folder, httpFile)
        use reader = new IO.StreamReader(fileHttp)
        let mutable html = reader.ReadToEnd()
        reader.Close()
        let externalImage = "external.gif"
        let subfolderFiles = "Files"
        let imgTagExternal = "<img class=\"externImage\" src=\"./" + subfolderFiles + "/" + externalImage + "\" alt=\"" + externalImage + "\" />"
        let regExprAWithHrefContentFormat = "<\s*a\s+(\s\S[^>])*?href=\"({0})\"(\s[^>]*)?>[\s\S]*?<\s*/a\s*>"
        //let localFileArg = Regex.Replace(Regex.Replace(localFile, "\(", "\\("), "\)", "\\)") 
        let urlArg = Regex.Replace(Regex.Replace(url, "\(", "\\("), "\)", "\\)") 
        let regExprAWithHrefContent = String.Format(regExprAWithHrefContentFormat, urlArg) 
        let reAWithHrefContent = new Regex(regExprAWithHrefContent, RegexOptions.IgnoreCase)
        let matchsAWithHrefContent = reAWithHrefContent.Matches(html)
        if (matchsAWithHrefContent.Count > 0) then
            let len1ImgTagExternal = imgTagExternal.Length + 1 
            for i = matchsAWithHrefContent.Count - 1 downto 0 do
                let matchAWithHrefContent = matchsAWithHrefContent.Item(i);
                let htmlRest = html.Substring(matchAWithHrefContent.Index + matchAWithHrefContent.Length);
                html <- html.Substring(0, matchAWithHrefContent.Index) 
                    + Regex.Replace(matchAWithHrefContent.Value, urlArg, localFile) 
                    + Regex.Replace(htmlRest.Substring(0, len1ImgTagExternal), " " + imgTagExternal, "")
                    + htmlRest.Substring(len1ImgTagExternal)
            //use writer = new IO.StreamWriter(Path.Combine(folder, httpFile), false, Encoding.UTF8)
            //writer.Write(html)
            html
        else
            ""
    else
        ""              

let GetFilesInFolder(folder: string): string[] =
    folder
    |> Directory.GetFiles
    |> Array.map Path.GetFileName 

let InitHashSetFilesInFolder(folder: string): HashSet<string> =
    new HashSet<string>(GetFilesInFolder(folder))

let folder = @"C:\Documents and Settings\Michael\Мои документы\MSDN\IndexingSearch"
let html = ReplaceLinksToLocalFile(folder, "http://msdn.microsoft.com/en-us/library/ms691002(v=VS.85).aspx", "ms691002(v=VS.85).htm", "ms691105(v=VS.85).htm")
*)
//let hsFilesInFolder = InitHashSetFilesInFolder(folder)
//for hf in hsFilesInFolder do ReplaceLinksToLocalFile(folder, "http://msdn.microsoft.com/en-us/library/ms691002(v=VS.85).aspx", "ms691002(v=VS.85).htm", hf)

(*
let GetFileContents (file: string): string =
    use sr = File.OpenText(file)
    sr.ReadToEnd()

let GetListLinksEx(htmlLinksPart: string) =
    let regExrLinks = "<\s*a(\s[^>]*)?>[\s\S]*?<\s*/a\s*>"
    let reLinks = new Regex(regExrLinks, RegexOptions.IgnoreCase)
    let matchColLinks = reLinks.Matches(htmlLinksPart)
    let regExrHref = "href\s*=\s*\"([^\"]*)\""
    let mutable retVal = []
    for m in matchColLinks do if (m.Success && m.Groups.Count > 1) then 
                                let matchAttrHref = Regex.Match(m.Groups.Item("1").Captures.Item(0).Value,
                                                                regExrHref, 
                                                                RegexOptions.IgnoreCase)
                                if (matchAttrHref.Success && matchAttrHref.Groups.Count > 1) then
                                    retVal <- (m.Groups.Item(0).Index, 
                                        m.Groups.Item(0).Length, 
                                        m.Groups.Item(0).Value, 
                                        matchAttrHref.Groups.Item("1").Captures.Item(0).Value)::retVal
    retVal

let GetListSrc(html: string): (int*int*string*string) list =
    let regExprSrc = "src\s*=\s*\"([^\"]*)\""
    let reLinks = new Regex(regExprSrc, RegexOptions.IgnoreCase)
    let matchColLinks = reLinks.Matches(html)
    let mutable retVal = []
    for m in matchColLinks do if (m.Success && m.Groups.Count > 1) then 
                                    retVal <- (m.Groups.Item(0).Index, 
                                        m.Groups.Item(0).Length, 
                                        m.Groups.Item(0).Value, 
                                        m.Groups.Item("1").Captures.Item(0).Value)::retVal
    retVal

let html = GetFileContents(@"C:\Documents and Settings\Michael\Application Data\MSDN\FSharp\dd233154.htm")
//let lstPosLinks = GetListLinksEx(html)  
let lstPosSrcs = GetListSrc(html)
*)
(*
let url = "//js.microsoft.com/library/svy/sto/broker.js"  
let regExprHttp = "http[s]{0,1}://\s*\S*"
let uri = if (not <| Regex.Match(url, regExprHttp).Success) then "http:" + url else url
*)
(*
let GetFileContents (file: string): string =
    use sr = File.OpenText(file)
    sr.ReadToEnd()

let GetUrlForHtmlDoc(html: string): string =
    let regExprLinkCanonical = "<\s*link\s+[\s\S]*?rel=\"canonical\"([\s\S]*?)\s+/\s*>"
    let regExprAttrHref = "href\s*=\s*\"([^\"]*)\""
    let reLinkCanonical = new Regex(regExprLinkCanonical, RegexOptions.IgnoreCase)
    let matchLinkCanonical = reLinkCanonical.Match(html)
    if (matchLinkCanonical.Success && matchLinkCanonical.Groups.Count > 0) then
        Regex.Match(matchLinkCanonical.Groups.Item(1).Captures.Item(0).Value, 
            regExprAttrHref).Groups.Item("1").Captures.Item(0).Value 
    else        
        ""
let url = @"C:\Documents and Settings\Michael\Application Data\MSDN\FSharp\dd233147.htm" |> GetFileContents |> GetUrlForHtmlDoc
*)

(*
let xmlToc = XElement.Load(@"C:\Documents and Settings\Michael\Application Data\MSDN\FSharp\dd233147.htm")
xmlToc.FirstNode.Remove()
let mutable lstUrl = []
for nodeLink in xmlToc.Descendants(XName.Get("link")) do 
    let href = nodeLink.Element(XName.Get("href")).Value
*)
(*
let xmlToc = XElement.Load(@"C:\Documents and Settings\Michael\Application Data\MSDN\FSharp\dd233147.xml")
xmlToc.FirstNode.Remove()

let res =
    xmlToc.Descendants(XName.Get("link"))
    |> List.ofSeq 
    |> List.map (fun e -> e.Element(XName.Get("href")).Value)
*)
(*
let e1 = "value1"
let e2 = "value2"
let args: obj[] = [|e1; e2|]
//args.[0] <- e1 :?> obj
//args.[1] <- e2 :?> obj
//args.[0] <- e1 :> obj
//args.[1] <- e2 :> obj
*)
(*
let DownloadUrlToFile(purl: string, url: string, file: string) =
    let regExprHttp = "http[s]{0,1}://\s*\S*"
    let uri = if (not <| Regex.Match(url, regExprHttp).Success) then 
                    let puri = new Uri(purl)
                    if (url.[0..1] = "//") then  
                        puri.Scheme + ":" + url
                    else     
                        puri.Scheme + "://" + puri.Host + url
              else url
    let req: HttpWebRequest = WebRequest.Create(new Uri(uri)) :?> HttpWebRequest
    req.UseDefaultCredentials <- true
    req.KeepAlive <- false
    use stream = req.GetResponse().GetResponseStream()
    stream.CopyTo(File.OpenWrite(file)) 

let r = DownloadUrlToFile("http://msdn.microsoft.com/ru-ru/library/kx37x362.aspx", (*"//js.microsoft.com/library/svy/sto/broker.js"*) "/Areas/Global/Content/CodeSnippet.js", @"C:\Temp\CodeSnippet.js")
*)
(*
let ApplyReplaceLstExprs(html: string, lstReplacement: (string*string) list): string =
    let mutable retVal = html
    for (rexpr, texpr) in lstReplacement do
        retVal <- Regex.Replace(retVal, rexpr, texpr)
    retVal

let res = ApplyReplaceLstExprs("&lt; &gt; &amp;", [("&lt;", "<"); ("&gt;", "<"); ("&amp;", "&")])
*)
let manager = new CSearchManagerClass()
let catalogManager = manager.GetCatalog("SystemIndex");
let queryHelper = catalogManager.GetQueryHelper();
queryHelper.QuerySelectColumns <- "System.ItemName,System.Title" //,System.Search.AutoSummary
//System.Search.AutoSummary,System.Search.ContainerHash,System.Search.Contents,System.Search.EntryID,System.Search.GatherTime,System.Search.HitCount,System.Search.IsClosedDirectory,System.Search.IsFullyContained,System.Search.QueryFocusedSummary,System.Search.QueryFocusedSummaryWithFallback,System.Search.Rank,System.Search.Store,System.Search.UrlToIndex,System.Search.UrlToIndexWithModificationTime" //System.Search.ExtendedProperties
queryHelper.QueryWhereRestrictions <- @" AND scope='file:C:\Documents and Settings\Michael\Мои документы\MSDN\FSharp' AND Contains(System.ItemType, '.htm')"
let sqlQuery = queryHelper.GenerateSQLFromUserQuery("Interactive"+" ")
let conn = new System.Data.OleDb.OleDbConnection(queryHelper.ConnectionString)
conn.Open()
let command = new System.Data.OleDb.OleDbCommand(sqlQuery, conn)
let wdsResults = command.ExecuteReader()
if (wdsResults.HasRows) then 
    let fieldCount = wdsResults.FieldCount 
    while (wdsResults.Read()) do
        for nField = 0 to fieldCount - 1 do
            let r = wdsResults.GetName(nField).ToString() + " = " + (if (wdsResults.GetString(nField).CompareTo(null) = 0) then 
                                                                        "(null)" 
                                                                     else
                                                                        wdsResults.GetString(nField).ToString().Trim())
            printf "%s\r\n" r
let x = 1