﻿// Learn more about F# at http://fsharp.net
module UrlDownLoader

open System
open System.Windows.Forms
open Resoures
open WebTools

[<STAThread>]
[<EntryPoint>]
let main(args) = 
  Application.EnableVisualStyles();
  Application.SetCompatibleTextRenderingDefault(false);
  Application.ThreadException.AddHandler(fun s e -> 
    Application.UseWaitCursor <- false
    ignore(MessageBox.Show(
            null, 
            e.Exception.ToString(), 
            Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
            MessageBoxButtons.OK, 
            MessageBoxIcon.Error)))
  AppDomain.CurrentDomain.UnhandledException.AddHandler(fun s e ->
    Application.UseWaitCursor <- false
    ignore(MessageBox.Show(
            null, 
            e.ExceptionObject.ToString(), 
            Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
            MessageBoxButtons.OK, 
            MessageBoxIcon.Error))) 
  try
    //let lstLinks = GetHtmlAndLinksFromSource(@"C:\Documents and Settings\Michael\Мои документы\Downloads\Visual F#.htm") 
    //let html, lstLinks = GetHtmlAndLinksFromSource(@"C:\Documents and Settings\Michael\Мои документы\Downloads\Справочник по языку F#.htm") 
    //let lstLinks = GetHtmlAndLinksFromSource(@"http://homeserver/default.htm") 
    //let lstData = lstLinks.Head
    //let html = lstData.Item1
    //let lsts = lstLinks.Tail 
    Application.Run(new MainForm.MainForm())
  with
    | _ as ex -> ignore(MessageBox.Show(
                                        null, 
                                        ex.ToString(), 
                                        Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                                        MessageBoxButtons.OK, 
                                        MessageBoxIcon.Error)) 
  0

