﻿namespace UrlDownLoaderResources
{

    public static class CommonDefs
    {
        static public string RegExprAContent = @"<\s*a(\s[^>]*)?>[\s\S]*?<\s*/a\s*>";
        static public string RegExprBody = @"<\s*body(\s[^>]*)?>[\s\S]*?<\s*/body\s*>";
        static public string RegExprDivClsToclevel1OrCommunityContentNavigation = @"<\s*div\s+\w*class=\""(toclevel1\s+\w*|communityContentNavigation)\""(\s[^>]*)?>[\s\S]*?<\s*/div\s*>";
        static public string RegExprDivClsTopicContainerOrTopicEndLine = @"<\s*div\s+\w*class=\""(topicContainer|topicEndLine)\""(\s[^>]*)?>[\s\S]*?<\s*/div\s*>";
        static public string RegExprAttrHref = @"href\s*=\s*\""([^\""]*)\""";
        static public string RegExprAttrTitle = @"title\s*=\s*\""([^\""]*)\""";
        static public string RegExprAttrHrefOrSrc = @"href\s*=\s*\""([^\""]*)\""|src\s*=\s*\""([^\""]*)\""";
        static public string RegExprHttp = @"http[s]{0,1}://\s*\S*";
        static public string RegExprAspExt = @".asp[x]{0,1}";
        static public string HtmlExt = @".htm";
        static public string FileSiteInfo = @"siteInfo.xml";
    }
}