﻿module ErrorsForm

open System
open System.Drawing 
open System.Windows.Forms
open SiteInfo
open Resoures

type ErrorsForm(lstErrors: (string*string) list) as this = 
    inherit Form() 

    let mutable components: System.ComponentModel.Container = null
    let mutable txtErrors: System.Windows.Forms.TextBox = null
    let mutable btnClose: System.Windows.Forms.Button = null

    do this.InitializeComponent();
        for (obj, msg) in lstErrors do 
            txtErrors.Text <- txtErrors.Text + "--- " + obj + " -> " + msg + "\r\n"
     

    override this.Dispose(disposing) =
        if (disposing && (match components with null -> false | _ -> true)) then
          components.Dispose();
        base.Dispose(disposing)

    member private this.InitializeComponent() =
        components <- new System.ComponentModel.Container();
        let resources = new System.ComponentModel.ComponentResourceManager(typeof<ErrorsForm>)
        txtErrors <- new System.Windows.Forms.TextBox();
        btnClose <- new System.Windows.Forms.Button();
        this.SuspendLayout();
        // 
        // txtErrors
        // 
        resources.ApplyResources(txtErrors, "txtErrors");
        txtErrors.Name <- "txtErrors";
        txtErrors.ReadOnly <- true;
        // 
        // btnClose
        // 
        resources.ApplyResources(btnClose, "btnClose");
        btnClose.DialogResult <- System.Windows.Forms.DialogResult.Cancel;
        btnClose.Name <- "btnClose";
        btnClose.UseVisualStyleBackColor <- true;
        btnClose.Click.AddHandler(fun s e -> this.Close(););  
        // 
        // ErrorsForm
        // 
        resources.ApplyResources(this, "$this");
        this.AutoScaleMode <- System.Windows.Forms.AutoScaleMode.Font;
        this.CancelButton <- btnClose;
        this.Controls.Add(btnClose);
        this.Controls.Add(txtErrors);
        this.MinimizeBox <- false;
        this.Name <- "ErrorsForm";
        this.ShowInTaskbar <- false;
        this.TopMost <- true;
        this.ResumeLayout(false);
        this.PerformLayout()
