﻿module SiteInfo

open System
open System.Runtime.Serialization
open System.Xml
open System.Xml.Serialization

[<Serializable>]
[<DataContract(Name="SiteInfo", Namespace="http://schemas.datacontract.org/2004/07/UrlDownLoader")>] 
type public SiteInfo(?url: string, ?lang: string) =
    let mutable m_url: string = defaultArg url "" 
    let mutable m_lang: string = defaultArg lang "" 
    [<DataMember(Name="url")>]
    member this.url with get(): string = m_url and set(newVal: string) = m_url <- newVal
    [<DataMember(Name="lang")>]
    member this.lang with get(): string = m_lang  and set(newVal: string) = m_lang <- newVal
    new() = new SiteInfo()
